require 'modshogun'

f_feats_train = modshogun.CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = modshogun.CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = modshogun.CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")
f_labels_test = modshogun.CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat")

--![create_features]
features_train = modshogun.RealFeatures(f_feats_train)
features_test = modshogun.RealFeatures(f_feats_test)
labels_train = modshogun.MulticlassLabels(f_labels_train)
labels_test = modshogun.MulticlassLabels(f_labels_test)
--![create_features]

--![create_instance]
qda = modshogun.QDA(features_train, labels_train, 0.0001, True)
--![create_instance]

--![train_and_apply]
qda:train()
labels_predict = qda:apply_multiclass(features_test)
--![train_and_apply]

--![extract_mean_and_cov]
classlabel = 1
m = qda:get_mean(classlabel)
c = qda:get_cov(classlabel)
--![extract_mean_and_cov]

--![evaluate_accuracy]
eval = modshogun.MulticlassAccuracy()
accuracy = eval:evaluate(labels_predict, labels_test)
--![evaluate_accuracy]

-- additional integration testing variables
output = labels_predict:get_labels()

-- Serialize output for integration testing (automatically generated)
__sg_storage = modshogun.WrappedObjectArray()
__sg_storage_file = modshogun.SerializableAsciiFile("quadratic_discriminant_analysis.dat", 'w')
__sg_storage:append_wrapped_int(classlabel, "classlabel")
__sg_storage:append_wrapped_real_vector(m, "m")
__sg_storage:append_wrapped_real_matrix(c, "c")
__sg_storage:append_wrapped_real(accuracy, "accuracy")
__sg_storage:append_wrapped_real_vector(output, "output")
__sg_storage:save_serializable(__sg_storage_file)
